import { PickedInfo } from "../../scene-manager";
import { Event, JsonValue, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import { ESSceneObject } from "../ESSceneObject";
export declare type GeoLocationMeasurementTextFuncType = (position: [number, number, number]) => string;
export declare class GeoLocationMeasurement extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<JsonValue>;
        show: boolean;
        allowPicking: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        editing: boolean;
        shadowDom: boolean;
        cssAllInitial: boolean;
    };
    get json(): JsonType;
    set json(value: JsonType);
    get geoJson(): JsonValue;
    set geoJson(value: JsonValue);
    get geoJsonStr(): string;
    set geoJsonStr(value: string);
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    static defaultTextFunc_度格式: (position: [number, number, number]) => string;
    static defaultTextFunc_度分格式: (position: [number, number, number]) => string;
    static defaultTextFunc_度分秒格式: (position: [number, number, number]) => string;
    private _textFunc;
    get textFunc(): GeoLocationMeasurementTextFuncType | undefined;
    set textFunc(value: GeoLocationMeasurementTextFuncType | undefined);
    get textFuncChanged(): Listener<[GeoLocationMeasurementTextFuncType | undefined, GeoLocationMeasurementTextFuncType | undefined]>;
    constructor(id?: SceneObjectKey);
    static defaults: {
        show: boolean;
        allowPicking: boolean;
        position: [number, number, number];
        editing: boolean;
        viewerTagsEnums: [string, string][];
    };
    getProperties(language?: string): import("../ESSceneObject").Property[];
}
export declare namespace GeoLocationMeasurement {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<JsonValue>;
        show: boolean;
        allowPicking: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        editing: boolean;
        shadowDom: boolean;
        cssAllInitial: boolean;
    };
}
export interface GeoLocationMeasurement extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof GeoLocationMeasurement.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof GeoLocationMeasurement.createDefaultProps> & {
    type: string;
}>;
export {};
