import { PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import { PlayerTracker } from "../MiscObjects";
import { ESSceneObject } from "../ESSceneObject";
import { GeoPathTracker } from "./GeoPathTracker";
export declare class GeoSceneObjectPathPlayerTracker extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        playerId: string;
        playerEvalFuncStr: string;
        pathId: string;
        targetObjId: string;
        usePosition: boolean;
        useRotation: boolean;
        targetPositionPropertyName: string;
        targetRotationPropertyName: string;
        positionDebug: boolean;
        rotationDebug: boolean;
        positionEvalFuncStr: string;
        rotationEvalFuncStr: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _geoPathTracker;
    get geoPathTracker(): GeoPathTracker;
    private _playerTracker;
    get playerTracker(): PlayerTracker;
    /**
     * 强制执行
     */
    forceExecute(): void;
    constructor(id?: SceneObjectKey);
    getProperties(language?: string): import("../ESSceneObject").Property[];
}
declare const extraComponentProps: {
    playerId: string;
    playerEvalFuncStr: string;
    pathId: string;
    targetObjId: string;
    usePosition: boolean;
    useRotation: boolean;
    targetPositionPropertyName: string;
    targetRotationPropertyName: string;
    positionDebug: boolean;
    rotationDebug: boolean;
    positionEvalFuncStr: string;
    rotationEvalFuncStr: string;
};
export declare namespace GeoSceneObjectPathPlayerTracker {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean;
    };
}
export interface GeoSceneObjectPathPlayerTracker extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof GeoSceneObjectPathPlayerTracker.createDefaultProps> & typeof extraComponentProps> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof GeoSceneObjectPathPlayerTracker.createDefaultProps> & typeof extraComponentProps & {
    type: string;
}>;
export {};
