import { ESSceneObject, PickedInfo, Viewer } from "../../scene-manager";
import { Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
export declare type DivInstanceClass<DivClass extends {
    destroy(): undefined;
} = {
    destroy(): undefined;
}> = (new (subContainer: HTMLDivElement, customDiv: CustomDiv<DivClass>, viewer?: Viewer | undefined) => DivClass);
export declare class CustomDiv<DivClass extends {
    destroy(): undefined;
} = {
    destroy(): undefined;
}> extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        show: boolean;
        instanceClassStr: string | undefined;
        innerHTML: string | undefined;
        allowPicking: boolean | undefined;
        containerId: string | undefined;
        shadowDom: boolean;
        cssAllInitial: boolean;
        cssText: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _updateEvent;
    update(updateFunc: (divClass: DivClass, customDiv: CustomDiv<DivClass>, viewer: Viewer) => void): void;
    private _instanceClassReact;
    get instanceClass(): DivInstanceClass<DivClass> | undefined;
    set instanceClass(value: DivInstanceClass<DivClass> | undefined);
    get instanceClassChanged(): Listener<[DivInstanceClass<DivClass> | undefined, DivInstanceClass<DivClass> | undefined]>;
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _innerHtmlMounted;
    get innerHtmlMounted(): Listener<[contentDiv: HTMLDivElement, viewer: Viewer]>;
    pickFromDiv(element: HTMLElement, childPickedInfo?: PickedInfo): void;
    private _container;
    get container(): HTMLElement | undefined;
    get containerChanged(): Listener<[HTMLElement | undefined, HTMLElement | undefined]>;
    set container(value: HTMLElement | undefined);
    static defaults: {
        show: boolean;
        containerId: string;
        viewerTagsEnums: [string, string][];
    };
    private _div;
    get div(): HTMLDivElement;
    private _containerIdResetting;
    private _instanceClassResetting;
    constructor(id?: SceneObjectKey);
    static defaultInnerHTML: string;
    static innerHTMLReadMe: string;
    getProperties(language?: string): import("../../scene-manager").Property[];
}
export declare namespace CustomDiv {
    const createDefaultProps: () => {
        show: boolean;
        instanceClassStr: string | undefined;
        innerHTML: string | undefined;
        allowPicking: boolean | undefined;
        containerId: string | undefined;
        shadowDom: boolean;
        cssAllInitial: boolean;
        cssText: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
}
export interface CustomDiv<DivClass extends {
    destroy(): undefined;
} = {
    destroy(): undefined;
}> extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CustomDiv.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CustomDiv.createDefaultProps> & {
    type: string;
}>;
export {};
