import { ESSceneObject, PickedInfo, PositionsEditing } from "vtxf-xe2/dist-node/xe2-base-objects";
import { Destroyable, Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import { CzmPolylineGroundPrimitive } from "./CzmPolylineGroundPrimitive";
import * as Cesium from 'cesium';
import { CzmViewer } from "../../core";
export declare type SectioningAnalysisSegmentsType = {
    p: [number, number, number];
    c: Cesium.Cartographic;
    distance: number;
    accumDistance: number;
    height: number;
};
export declare type SectioningAnalysisResultType = {
    p0: [number, number, number];
    p1: [number, number, number];
    c0: Cesium.Cartographic;
    c1: Cesium.Cartographic;
    ellipsoidGeodesic: Cesium.EllipsoidGeodesic;
    distance: number;
    accumDistance: number;
    segments: SectioningAnalysisSegmentsType[];
};
export declare class SectioningAnalysis extends Destroyable {
    private _czmViewer;
    private _sceneObject;
    get sceneObject(): CzmSectioningLine;
    get czmViewer(): CzmViewer;
    constructor(_czmViewer: CzmViewer, _sceneObject: CzmSectioningLine);
}
export declare class CzmSectioningLine extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean;
        positions: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number][] | undefined>;
        editing: boolean;
        allowPicking: boolean;
        defaultSegmentsNum: number;
        segmentsNumArray: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<number[]>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    private _sPositionsEditing;
    get sPositionsEditing(): PositionsEditing;
    private _forceUpdateEvent;
    get forceUpdateEvent(): Event<[]>;
    forceUpdate(): void;
    private _analysisResult;
    get analysisResult(): SectioningAnalysisResultType[] | undefined;
    set analysisResult(value: SectioningAnalysisResultType[] | undefined);
    get analysisResultChanged(): Listener<[SectioningAnalysisResultType[] | undefined, SectioningAnalysisResultType[] | undefined]>;
    private _echartsOptionsStr;
    get echartsOptionsStr(): any;
    set echartsOptionsStr(value: any);
    get echartsOptionsStrChanged(): Listener<[string, string]>;
    private _line;
    get line(): CzmPolylineGroundPrimitive;
    private _sectioningChartPerView;
    constructor(id?: SceneObjectKey);
    getProperties(language?: string): import("vtxf-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmSectioningLine {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean;
        positions: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number][] | undefined>;
        editing: boolean;
        allowPicking: boolean;
        defaultSegmentsNum: number;
        segmentsNumArray: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<number[]>;
    };
}
export interface CzmSectioningLine extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmSectioningLine.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmSectioningLine.createDefaultProps> & {
    type: string;
}>;
export {};
